#ifndef _COMMON_HEADER_INCLUDED
#define _COMMON_HEADER_INCLUDED

#ifdef _DEBUG
#define PURE_VIRTUAL  { ASSERT(FALSE); }
#define PURE_VIRTUAL_FALSE  { ASSERT(FALSE); return 0; }
#else
#define PURE_VIRTUAL =0
#define PURE_VIRTUAL_FALSE =0
#endif

#include <map>
#include <string>
#include <list>
#include <sstream>
#include <vector>
#include <stack>
#include <set>

namespace std
	{
	template<class _Ty, class _C = deque<_Ty> >
		class fixed_stack : public stack<_Ty,_C>
		{
		public:
			typedef		_C container_type;
		public:
			_C&			_Get_c()		{ return c; };
			const _C&	_Get_c() const	{ return c;	};
		};
	};

#define stack fixed_stack

#ifdef _UNICODE
namespace std {
	typedef	std::basic_string<wchar_t>			tstring;
	typedef std::basic_stringstream<wchar_t>	tstringstream;
	};
#else
namespace std {
	typedef	std::basic_string<char>				tstring;
	typedef std::basic_stringstream<char>		tstringstream;
	};
#endif

#include "common_error.h"

#include "tkCommon/ctkFlagsMixin.h"
#include "tkCommon/ctkMisc.h"
#include "tkCommon/ctkCheckValid.h"
#include "tkCommon/ctkExternalObjectPointer.h"
#include "tkCommon/ctkHLinkedList.h"
#include "tkCommon/ctkEnumerator.h"

#endif