/*********************************************************************
	Copyright (C) 2001 by

		Alexander Berthold, alexander-berthold@web.de.
		Hoegestr. 54
		79108 Freiburg i. Breisgau
		Germany

    -- This file is part of cxTokenizer --

    "cxTokenizer" is free software; you can redistribute it and/or 
	modify it under the terms of the GNU Lesser General Public 
	License as published by the Free Software Foundation; either 
	version 2 of the License, or any later version.

    "cxTokenizer" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
	License along with "cxTokenizer"; if not, write to the Free 
	Software  Foundation, Inc., 59 Temple Place, Suite 330, 
	Boston, MA  02111-1307  USA

    ---------------------------------------------------------------
      If you find any bugs or if you make other corrections/
	  enhancements, i'd appreciate if you'd let me know about 
	  that. My email is
  
       alexander-berthold@web.de
  
      If you share this code, do not remove this text.
    ---------------------------------------------------------------

Class:      cxTokenizerCharTokenRule
Author:     Alexander Berthold
Copyright:  Alexander Berthold
Date:       2001/12/19
Version:	0.2.01
Purpose: 
	-	Class for string based tokenizer rules

Version history:

	-	2001/04/19
		First functional version implemented and released (0.1.13).

	-	2001/12/19
		Current source labeled version 0.2.01

*********************************************************************/

// cxTokenizerCharTokenRule.h: interface for the cxTokenizerCharTokenRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CXTOKENIZERCHARTOKENRULE_H__D823B834_7F51_4D60_942E_5269478B9FC1__INCLUDED_)
#define AFX_CXTOKENIZERCHARTOKENRULE_H__D823B834_7F51_4D60_942E_5269478B9FC1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class cxTokenizerCharTokenRule : public cxTokenizerTokenRule  
{
// Construction/destruction
public:
	cxTokenizerCharTokenRule(int nIDValue, xttr_flags ltrf, LPCTSTR lpszToken, const std::tstring& strInitString);
	virtual ~cxTokenizerCharTokenRule();

// Operations
public:
	// cooParserTokenRule operations
	virtual bool	fDoesApply(const cxTokenizerContext *ptcContext, TCHAR tcChar, bool *pfCompleted, 
							   int nStartPos, int nCurPos) const;
	virtual void	vApplied( cxTokenizerContext *ptcContext, TCHAR tcChar, bool fComplete, 
							  int nStartPos, int nCurPos) const;
	virtual bool	fGetResultString(const cxTokenizerContext* /*ptcContext*/, std::tstring& /* strResult */) const
					{ return false; };
};

#endif // !defined(AFX_CXTOKENIZERCHARTOKENRULE_H__D823B834_7F51_4D60_942E_5269478B9FC1__INCLUDED_)
