/*********************************************************************
	Copyright (C) 2001/2 by

		Alexander Berthold, alexander-berthold@web.de.
		Hoegestr. 54
		79108 Freiburg i. Breisgau
		Germany

    -- This file is part of cxTokenizer --

    "cxTokenizer" is free software; you can redistribute it and/or 
	modify it under the terms of the GNU Lesser General Public 
	License as published by the Free Software Foundation; either 
	version 2 of the License, or any later version.

    "cxTokenizer" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
	License along with "cxTokenizer"; if not, write to the Free 
	Software  Foundation, Inc., 59 Temple Place, Suite 330, 
	Boston, MA  02111-1307  USA

    ---------------------------------------------------------------
      If you find any bugs or if you make other corrections/
	  enhancements, i'd appreciate if you'd let me know about 
	  that. My email is
  
       alexander-berthold@web.de
  
      If you share this code, do not remove this text.
    ---------------------------------------------------------------

Class:      cxTokenizerContextCookie
Author:     Alexander Berthold
Copyright:  Alexander Berthold
Date:       2001/12/19
Version:	0.2.01
Purpose:    This class is the base class for custom cookies.
            See cxTokenizerStringContextCookie, 
            cxTokenizerNumberContextCookie for applications.


Version history:
	-	2001/05/19
		Renamed class from 'cpLexxerContextCookie' to 'cxTokenizerContextCookie'.

	-	2001/12/19
		Current source labeled version 0.2.01

*********************************************************************/

// cxTokenizerContextCookie.h: interface for the cxTokenizerContextCookie class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CXTOKENIZERCONTEXTCOOKIE_H__C591692E_3C3D_4E2B_A9F2_C7697F22EED5__INCLUDED_)
#define AFX_CXTOKENIZERCONTEXTCOOKIE_H__C591692E_3C3D_4E2B_A9F2_C7697F22EED5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class cxTokenizerContextCookie :
	public ctkCheckValid
{
// Construction/Destruction
public:
	cxTokenizerContextCookie()
        {};
	virtual ~cxTokenizerContextCookie()
        {};

// Attributes
protected:
	DWORD			m_dwMyCookieID;

// Operations
public:
	virtual	bool	fCheckValid() const
					{ return true; };
	DWORD			dwGetCookieID()
					{	return m_dwMyCookieID;	};

	friend class cxTokenizerContext;
};

#endif // !defined(AFX_CXTOKENIZERCONTEXTCOOKIE_H__C591692E_3C3D_4E2B_A9F2_C7697F22EED5__INCLUDED_)
