#ifdef _DEBUG

#include "cxTokenizerCharTokenRule.h"

bool	cxTokenizerContext::fRunDiagnostics()
	{
	cxTokenizerContext	ctx;
	cxListEntry			*pteOne, *pteTwo, *pteThree;

	pteOne			=new cxListEntry(5,(cxTokenizerMapData*)1);
	pteTwo			=new cxListEntry(7,(cxTokenizerMapData*)2);
	pteThree		=new cxListEntry(9,(cxTokenizerMapData*)3);

	if(pteOne->fIsCompleted())
		return false;
	if(pteTwo->fIsCompleted())
		return false;
	if(pteThree->fIsCompleted())
		return false;

	pteOne->vSetCompleted(10,(cxTokenizerMapData*)1);
	if(!pteOne->fIsCompleted())
		return false;
	pteTwo->vSetCompleted(11,(cxTokenizerMapData*)1);
	pteTwo->vSetNotApplying();
	if(!pteTwo->fIsNotApplying())
		return false;
	pteThree->vMarkForDeletion();
	if(!pteThree->fIsMarkedForDeletion())
		return false;

	ctx.m_lstTokenRules.push_back(pteOne);
	ctx.m_lstTokenRules.push_back(pteTwo);
	ctx.m_lstTokenRules.push_back(pteThree);

	if(ctx.nDeleteMarkedListEntries()!=1)
		return false;

	if(ctx.m_lstTokenRules.size()!=2)
		return false;

	cxTokenizerContextCookie *pCookie = new cxTokenizerContextCookie();
	cxTokenizerCharTokenRule *pRule = new cxTokenizerCharTokenRule(0,ttrf_character_rule,_T(""),_T(""));

	if(ctx.ptccGetCookie(pRule)!=NULL)
		return false;
	if(!ctx.fSetCookie(pRule,pCookie))
		return false;
	if( ctx.fSetCookie(pRule,pCookie))
		return false;
	if(ctx.ptccGetCookie(pRule)!=pCookie)
		return false;

	delete pRule;

	if(ctx.m_mapCookies.begin()==ctx.m_mapCookies.end())
		return false;

	ctx.m_strCurrentText=_T("-test-");

	ctx.vCleanUpAfterTokenRecognition();

	if(ctx.m_mapCookies.begin()!=ctx.m_mapCookies.end())
		return false;

	if(ctx.m_lstTokenRules.size()!=0)
		return false;

	if(ctx.m_strCurrentText.length()!=0)
		return false;

	return true;
	}

bool	cxTokenizerContext::cxListEntry::fCheckValid() const
	{
	if(ptmdRule==NULL)
		return false;
	if(ptmdRuleLastValid!=NULL)
		{
		if(!ptmdRuleLastValid->fCheckValid())
			return false;
		}
	if(fNotApplying && nEndPosition==-1)
		return false;

	return true;
	}

bool	cxTokenizerContext::fCheckValid() const
	{
	tc_list_type::const_iterator		it1;
	tc_cookiemap_type::const_iterator	it2;

	for(it1=m_lstTokenRules.begin();
		it1!=m_lstTokenRules.end();
		it1++)
		{
		cxListEntry	*pteCur = (*it1);
		if(!pteCur->fCheckValid())
			return false;
		}

	for(it2=m_mapCookies.begin();
		it2!=m_mapCookies.end();
		it2++)
		{
		const cxTokenizerTokenRule	*pttrTemp;
		cxTokenizerContextCookie	*ptccTemp;

		pttrTemp	=(const cxTokenizerTokenRule*)((*it2).first);
		ptccTemp	=(*it2).second;

		ASSERT(pttrTemp!=NULL);
		ASSERT(ptccTemp!=NULL);
		if(!pttrTemp->fCheckValid())
			return false;
		if(!ptccTemp->fCheckValid())
			return false;
		}

	return true;
	}

#endif