/*********************************************************************
	Copyright (C) 2001/2 by

		Alexander Berthold, alexander-berthold@web.de.
		Hoegestr. 54
		79108 Freiburg i. Breisgau
		Germany

    -- This file is part of cxTokenizer --

    "cxTokenizer" is free software; you can redistribute it and/or 
	modify it under the terms of the GNU Lesser General Public 
	License as published by the Free Software Foundation; either 
	version 2 of the License, or any later version.

    "cxTokenizer" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
	License along with "cxTokenizer"; if not, write to the Free 
	Software  Foundation, Inc., 59 Temple Place, Suite 330, 
	Boston, MA  02111-1307  USA

    ---------------------------------------------------------------
      If you find any bugs or if you make other corrections/
	  enhancements, i'd appreciate if you'd let me know about 
	  that. My email is
  
       alexander-berthold@web.de
  
      If you share this code, do not remove this text.
    ---------------------------------------------------------------

Class:      cxTokenizerException
Author:     Alexander Berthold
Copyright:  Alexander Berthold
Date:       2001/12/19
Version:	0.2.01
Purpose:    Any exceptions thrown in this package use this
            exception class. The exception code itself is based
            on a HRESULT code. There is also a possibility to reverse
            lookup the error code as text (LookupError())


Version history:

	-	2001/05/19
		Renamed class from 'cpLexxerException' to 'cxTokenizerException'.

	-	2001/06/05
		Current source labeled version 0.1.15

    -	2001/12/15
		Added support for description string (m_pszCause) and derived
		from ctkExceptionBase

	-	2001/12/19
		Labeled version 0.2.01
		
*********************************************************************/

// cxTokenizerException.h: interface for the cxTokenizerException class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CXTOKENIZEREXCEPTION_H__2A2ED892_5CBE_41BC_90E3_533C3A4AF76C__INCLUDED_)
#define AFX_CXTOKENIZEREXCEPTION_H__2A2ED892_5CBE_41BC_90E3_533C3A4AF76C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class cxTokenizerException : public ctkExceptionBase
{
// Construction/Destruction
public:
	cxTokenizerException(HRESULT hr, LPCTSTR lpszCause=NULL)
		: ctkExceptionBase(hr,lpszCause)
		{};

	virtual ~cxTokenizerException()
        {};
};

#endif // !defined(AFX_CXTOKENIZEREXCEPTION_H__2A2ED892_5CBE_41BC_90E3_533C3A4AF76C__INCLUDED_)
