/*********************************************************************
	Copyright (C) 2001/2 by

		Alexander Berthold, alexander-berthold@web.de.
		Hoegestr. 54
		79108 Freiburg i. Breisgau
		Germany

    -- This file is part of cxTokenizer --

    "cxTokenizer" is free software; you can redistribute it and/or 
	modify it under the terms of the GNU Lesser General Public 
	License as published by the Free Software Foundation; either 
	version 2 of the License, or any later version.

    "cxTokenizer" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
	License along with "cxTokenizer"; if not, write to the Free 
	Software  Foundation, Inc., 59 Temple Place, Suite 330, 
	Boston, MA  02111-1307  USA

    ---------------------------------------------------------------
      If you find any bugs or if you make other corrections/
	  enhancements, i'd appreciate if you'd let me know about 
	  that. My email is
  
       alexander-berthold@web.de
  
      If you share this code, do not remove this text.
    ---------------------------------------------------------------

Class:      cxTokenizerStringTokenRule
Author:     Alexander Berthold
Copyright:  Alexander Berthold
Date:       2001/12/19
Version:	0.2.01
Purpose:    Computed rule which recognizes string tokens.
            Processes strings embraced by "". Accepts escape
            sequences like \", \x0d.


Version history:

	-	2001/05/19
		Renamed class from 'cpLexxerStringTokenRule' to 
		'cxTokenizerStringTokenRule'.

	-	2001/12/19
		Current source labeled version 0.2.01
		
*********************************************************************/

// cxTokenizerStringTokenRule.h: interface for the cxTokenizerStringTokenRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CXTOKENIZERSTRINGTOKENRULE_H__79C1EEB5_347E_4722_9223_11E25DC0E2EB__INCLUDED_)
#define AFX_CXTOKENIZERSTRINGTOKENRULE_H__79C1EEB5_347E_4722_9223_11E25DC0E2EB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum	spcc_escape_type {
	esc_begin=0,
	esc_octal,
	esc_hex
	};

class cxTokenizerStringContextCookie : public cxTokenizerContextCookie
{
// Construction/Destruction
public:
	cxTokenizerStringContextCookie()
		{
		fCompleted	=false;
		fInEscape	=false;
		};

// Attributes
public:
	bool				fCompleted;
	bool				fInEscape;
	spcc_escape_type	esct;

	std::tstring		strResult;
	std::tstring		strEsc;
};

class cxTokenizerStringTokenRule : public cxTokenizerTokenRule  
{
// Construction/Destruction
public:
	cxTokenizerStringTokenRule(int nIDValue, xttr_flags ttrf, const std::tstring& strInitString);
	virtual ~cxTokenizerStringTokenRule();

// Attributes
protected:

// Operations
public:
	virtual std::tstring strGetTokenString() const	{ return _T("string"); };

	virtual	bool	fCheckValid() const
					{ return true; };

	virtual bool	fDoesApply(	const cxTokenizerContext *ptcContext, TCHAR tcChar, bool *pfComplete, 
								int nStartPos, int nCurPos) const;
	virtual void	vApplied( cxTokenizerContext *ptcContext, TCHAR tcChar, bool fComplete, 
							  int nStartPos, int nCurPos) const;
	virtual bool	fGetResultString(const cxTokenizerContext *ptcContext, std::tstring& strResult) const;
};


#endif // !defined(AFX_CXTOKENIZERSTRINGTOKENRULE_H__79C1EEB5_347E_4722_9223_11E25DC0E2EB__INCLUDED_)
